package de.digisalt.tileEdit.model.dataContainers;

import java.awt.Color;

public abstract class AbstractPaletteContainer {
	private int rd[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	private int gd[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	private int bd[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	
	public AbstractPaletteContainer(boolean empty)
	{
		if (!empty)
		{			
			//color0
			rd[0] = 0;
			gd[0] = 0;
			bd[0] = 0;
			//color1
			rd[1] = 10;
			gd[1] = 10;
			bd[1] = 10;
			//color2
			rd[2] = 31;
			gd[2] = 0;
			bd[2] = 0;
			//color3
			rd[3] = 0;
			gd[3] = 31;
			bd[3] = 0;
			//color4
			rd[4] = 0;
			gd[4] = 0;
			bd[4] = 31;
			//color5
			rd[5] = 31;
			gd[5] = 31;
			bd[5] = 0;
			//color6
			rd[6] = 0;
			gd[6] = 31;
			bd[6] = 31;
			//color7
			rd[7] = 31;
			gd[7] = 0;
			bd[7] = 31;
			//color8
			rd[8] = 31;
			gd[8] = 31;
			bd[8] = 31;
			//color9
			rd[9] = 20;
			gd[9] = 20;
			bd[9] = 20;
			//color10
			rd[10] = 15;
			gd[10] = 0;
			bd[10] = 0;
			//color11
			rd[11] = 0;
			gd[11] = 15;
			bd[11] = 0;
			//color12
			rd[12] = 0;
			gd[12] = 0;
			bd[12] = 15;
			//color13
			rd[13] = 15;
			gd[13] = 15;
			bd[13] = 0;
			//color14
			rd[14] = 0;
			gd[14] = 15;
			bd[14] = 15;
			//color15
			rd[15] = 15;
			gd[15] = 0;
			bd[15] = 15;
		}
	}
	
	public Color getColor(int number) throws Exception
	{
		if (number < 0 || number > 15)
		{
			throw new Exception();
		}
		
		return new Color(Math.round(rd[number]*8), Math.round(gd[number]*8), Math.round(bd[number]*8));
	}
	
	public void setColor(int number, int r, int g, int b) throws Exception
	{
		if (number < 0 || number > 15 || r < 0 || r > 31 || g < 0 || g > 31 || b < 0 || b > 31)
		{
			throw new Exception();
		}
		rd[number] = r;
		gd[number] = g;
		bd[number] = b;
	}
	
	public boolean importColors(int[] input)
	{
		if (input.length != 50)
		{
			return false;
		}
		for (int i=0; i<=15; i++)
		{
			try {
				this.setColor(i, input[(i*3)+0], input[(i*3)+1], input[(i*3)+2]);
			} catch (Exception e) {
				//System.out.println("FEHLER! r|g|b @ i: " + (i*3+0) + "|" + (i*3+1) + "|" + (i*3+2) + " @ " + i);
				e.printStackTrace();
			}			
		}
		return true;
	}
}
