package de.digisalt.tileEdit.model.fileFilter;

import java.io.File;

import javax.swing.filechooser.FileFilter;

public class SnesTileFilter extends FileFilter 
{
	public boolean accept(File arg0) 
	{
		if (arg0.isDirectory()) 
		{
			return true;
		}
		
		String extension = Utils.getExtension(arg0);
		if (extension != null) 
		{
			if (extension.equals(Utils.snesImage) || extension.equals(Utils.binFile) || extension.equals(Utils.smcFile)) 
			{
				return true;
			} 
			else 
			{
				return false;
			}
		}
		
		return false;
	}
	//The description of this filter
	public String getDescription() 
	{
		return "SNES Image Files";
	}
	
	public static class Utils {

	    public final static String snesImage = "snesimg";
	    public final static String binFile = "bin";
	    public final static String smcFile = "smc";
	    /*
	     * Get the extension of a file.
	     */  
	    public static String getExtension(File f) {
	        String ext = null;
	        String s = f.getName();
	        int i = s.lastIndexOf('.');

	        if (i > 0 &&  i < s.length() - 1) {
	            ext = s.substring(i+1).toLowerCase();
	        }
	        return ext;
	    }
	}

}
