package de.digisalt.tileEdit.view.components;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;

import de.digisalt.tileEdit.controller.Commands;
import de.digisalt.tileEdit.controller.Controller;
import de.digisalt.tileEdit.view.layout.HIGConstraints;
import de.digisalt.tileEdit.view.layout.HIGLayout;

@SuppressWarnings("serial")
public class NewFileDialog extends JDialog{
	private static NewFileDialog instance = null;
	private JLabel lblWidth;
	private JLabel lblHeight;
	private JSpinner widthInput;
	private JSpinner heightInput;
	private JButton btnOk;
	private JButton btnCancel;
	
	public static NewFileDialog getInstance(JFrame owner)
	{
		if (instance == null)
		{
			instance = new NewFileDialog(owner);
		}
		return instance;
	}
	private NewFileDialog(final JFrame owner) 
	{
		super(owner, "New File");
		setDefaultCloseOperation(HIDE_ON_CLOSE);
		this.setResizable(false);
		int w1[] = new int[] {5, 10, 50, 2, 80, -1, -5, -1};
		int h1[] = new int[] {5, 20, -2, -2, -1, -2, -2, 25, -1};
		super.setLayout(new HIGLayout(w1, h1));
		this.setLayout(new HIGLayout(w1, h1));
		
		JLabel Header = new JLabel("Enter dimensions for the new image");
		
		lblWidth = new JLabel("Width: ");
		widthInput = new JSpinner();
		widthInput.setModel(new SpinnerNumberModel(1,1,16,1)); 
		JLabel Tiles1 = new JLabel("Tiles");
		
		
		lblHeight = new JLabel("Height: ");
		heightInput = new JSpinner();
		heightInput.setModel(new SpinnerNumberModel(1,1,64,1));
		JLabel Tiles2 = new JLabel("Tiles");
		
		btnOk = new JButton("Ok");
		btnOk.addMouseListener(new MouseListener() {
			public void mouseClicked(MouseEvent arg0) {}
			public void mouseEntered(MouseEvent arg0) {}
			public void mouseExited(MouseEvent arg0) {}
			public void mousePressed(MouseEvent arg0) {}
			public void mouseReleased(MouseEvent arg0) 
			{
				NewFileDialog.this.setVisible(false);
				Controller.getInstance().viewToModel(Commands.v2mNewFile, new Object[]{(Integer)heightInput.getModel().getValue(), (Integer)widthInput.getModel().getValue()});
			}
		});
		btnCancel = new JButton("Cancel");
		btnCancel.addMouseListener(new MouseListener() {
			public void mouseClicked(MouseEvent arg0) {}
			public void mouseEntered(MouseEvent arg0) {}
			public void mouseExited(MouseEvent arg0) {}
			public void mousePressed(MouseEvent arg0) {}
			public void mouseReleased(MouseEvent arg0) 
			{
				NewFileDialog.this.setVisible(false);
			}
		});
		
		HIGConstraints hc = new HIGConstraints();
		this.add(Header, hc.rcwh(2, 2, 6, 1));
		this.add(lblWidth, hc.rcwh(4, 3, 1, 1));
		this.add(widthInput, hc.rcwh(4, 4, 2, 1));
		this.add(Tiles1, hc.rcwh(4, 7, 1, 1));
		
		this.add(lblHeight, hc.rcwh(6, 3, 1, 1));
		this.add(heightInput, hc.rcwh(6, 4, 2, 1));
		this.add(Tiles2, hc.rcwh(6, 7, 1, 1));
		
		this.add(btnCancel, hc.rcwh(8, 5, 1, 1));
		this.add(btnOk, hc.rcwh(8, 7, 1, 1));
		
		
		pack();
		setVisible(true);
		setModal(true);	
	}
}
